package routine

import (
	"runtime"
	"sync/atomic"
	"testing"

	"github.com/brildum/testify/assert"
)

func TestPool(t *testing.T) {
	num := runtime.NumCPU()
	var sum atomic.Int32
	pool := NewPool(num, num, func(num int32) {
		if num < 0 {
			panic("unable to handle negative numbers")
		}

		sum.Add(num)
	})
	pool.Start()

	for i := int32(1000); i >= -1; i-- {
		pool.Push(i)
	}

	pool.Wait()

	if assert.Equal(t, int32(500500), sum.Load()) {
		t.Log("the sum value is right")
	}
}
